import java.awt.*;
import javax.swing.*;
import java.util.*;
import java.io.*;
public class BackTrack3 extends BaseSolver implements Solver{
	private int[][] grid;
	private Button[][] view;
	private int cons =0;
	private LinkedList freeList;
	private boolean stop = false;
	
	public BackTrack3(){
		super();
		
	}
	public void setGrid(int[][] g){
		this.grid=g;
		setFreeList();
	}
	public int[][] getGrid(){
		return this.grid;		
	}
	public boolean getStop(){
		return stop;
	}
	public void setView(Button[][] v){
		this.view=v;
		this.update();
	}
	public void setFreeList(){
		freeList= new LinkedList<Cell>();
		int[][] random=new int[9][9];
		int free=0;
		Cell v;
		//random
		for(int i=0; i < 9; i++){
			for(int j=0; j < 9; j++){
				if(grid[i][j] == 0){
					free++;	
				}
				random[i][j]=grid[i][j];
			}	
		}
		int index=0;
        	//initialization in random mode
        v= new Cell((int)(9*Math.random()),(int)(9*Math.random()));      	
	 	while(index < free){
        		if (random[v.r][v.c] == 0) {
        			freeList.add(v);
          			random[v.r][v.c]=-1;
          			index++;
        		}	
        		v= new Cell((int)(9*Math.random()),(int)(9*Math.random()));	
      		}
	}
		public boolean solve(int k){
			// if stop == true force the termination.
			if (stop){
				return false;
			}
			if( k >= freeList.size()){
				System.out.println("Totale assegnamenti: " + cons);
				return true;	
			}
			Cell v = (Cell) freeList.get(k);
			for(int i=1; i <= 9; i++){
				if (checkConsistency(v.r,v.c,i)){
					grid[v.r][v.c]=i;
					update(v.r,v.c);
					
					if (solve(k+1)){
						return true;	
					}	
				}	
			}
			// if stop == true force the termination. 
			if (stop){
				
				return false;
			}
			// to verify random grid
			//saveRandomGrid(k,cons);
			grid[v.r][v.c]=0;
			update(v.r,v.c);
			return false;
		}

		/*
		private void saveRandomGrid(int k, int c){
   		String name= Integer.toString(c);
   		FileWriter f= null;
   		try{
   			f= new FileWriter("./grid/testRandom-"+ name +".txt");
   			Cell v= new Cell(0,0);   
		for (int i=0; i < k-1; i++) {
			v= (Cell) freeList.get(i);
					f.write("assegnate" + k + "riga" +v.r + "colonna" + v.c);
					f.write("\n");
			v=null;
			}
				f.write("\n");
				f.flush();
				f.close();
		}catch(Exception e){
			
		}
			
   		}
		*/
		
	public void update(int r, int c){
		if( grid[r][c] != 0 ){
                	view[r][c].setLabel( String.valueOf(grid[r][c]) ) ;
		}else{
               		view[r][c].setLabel( "" );
      		}
	}

	private void update(){
	   	 for( int r = 0; r < 9; r++ ){
          		for( int c = 0; c < 9; c++ ){
		             update(r,c);
		         }
		}
	}
	public boolean checkConsistency(int r,int c, int n){
		cons++;
		return (checkRow(r,0,n) && checkCol(0,c,n) && checkBlock(r,c,n));
	}
	private boolean checkRow(int r, int c, int n){
		if(c < 9){
			if( this.grid[r][c] == n ){
            	return false ;
         	}else{
         		return checkRow(r,c+1,n);
         	}
		}
        return true;
	}
	private boolean checkCol(int r,int c, int n){
		if(r < 9){
			if( this.grid[r][c] == n ){
            	return false ;
         	}else{
         		return checkCol(r+1,c,n);
         	}
		}
        return true;
	}
	private boolean checkBlock(int r,int c, int n){
	 r = (r / 3) * 3 ;
     c = (c / 3) * 3 ;

      for( int i = 0; i < 3; i++ ){
         for( int j = 0; j < 3; j++ ){
         	if( grid[r+i][c+j] == n ){
            	return false ;
         	}
         }
	  }
      return true ;
	}

 
}
	
