import java.awt.*;
import javax.swing.*;
import java.util.*;
public class BackTrack4 extends BaseSolver implements Solver{
	private int[][] grid;
	private Button[][] view;
	private int cons =0;
	private LinkedList freeList;
	private boolean stop = false;
	
	int[] square = new int[9];
	
	public BackTrack4(){
		super();
		
	}
	public void setGrid(int[][] g){
		this.grid=g;
		setFreeList();
	}
	public int[][] getGrid(){
		return this.grid;		
	}
	public boolean getStop(){
		return stop;
	}
	public void setView(Button[][] v){
		this.view=v;
		this.update();
	}
	public void setFreeList(){
		freeList= new LinkedList<Cell>();
		for(int i=0; i < 9; i++){
			for(int j=0; j < 9; j++){
				if(grid[i][j] == 0){
					freeList.add(new Cell(i,j));	
				}else{
					square[getSquare(i,j)]++;
				}	
			}	
		}
	}
	public int getSquare(int r, int c){
		int sr= (r/3) *3;
		int sc= (c/3) *3;
		return (3*((sr/3 + 1)- 1) + sc/3);	
	}
		public boolean solve(int k){
			// if stop == true force the termination.
			if (stop){
				return false;
			}
			if( k >= freeList.size()){
				System.out.println("Totale assegnamenti: " + cons);
				return true;	
			}
			MostConstrainedSquareSelection(k);
			Cell v = (Cell) freeList.get(k);
			for(int i=1; i <= 9; i++){
				if (checkConsistency(v.r,v.c,i)){
					grid[v.r][v.c]=i;
					update(v.r,v.c);
					square[getSquare(v.r,v.c)]++;
					if (solve(k+1)){
						return true;	
					}
					square[getSquare(v.r,v.c)]--;	
				}		
			}
			// if stop == true force the termination. 
			if (stop){
				return false;
			}
			grid[v.r][v.c]=0;
			update(v.r,v.c);
			return false;
		}
		public void MostConstrainedSquareSelection(int k){
			if(k >= freeList.size()){
				return;	
			}	
			int max = -1;
			int imax = 0;
			for(int j=0; j < 9; j++){
				if(square[j] > max && square[j] < 9){
					max = square[j];
					imax=j;	
				}
			int length = freeList.size();
			Cell c;
			for(int i=k; i < length; i++){
				c = (Cell) freeList.get(i);
				if (getSquare(c.r,c.c) == imax){
					freeList.remove(c);
					
					freeList.add(k,c);	
					
				}	
			}
				
			}	
				
		}
	public void update(int r, int c){
		if( grid[r][c] != 0 ){
                	view[r][c].setLabel( String.valueOf(grid[r][c]) ) ;
		}else{
               		view[r][c].setLabel( "" );
      		}
	}

	private void update(){
	   	 for( int r = 0; r < 9; r++ ){
          		for( int c = 0; c < 9; c++ ){
		             update(r,c);
		         }
		}
	}
	public boolean checkConsistency(int r,int c, int n){
		cons++;
		return (checkRow(r,0,n) && checkCol(0,c,n) && checkBlock(r,c,n));
	}
	private boolean checkRow(int r, int c, int n){
		if(c < 9){
			if( this.grid[r][c] == n ){
            	return false ;
         	}else{
         		return checkRow(r,c+1,n);
         	}
		}
        return true;
	}
	private boolean checkCol(int r,int c, int n){
		if(r < 9){
			if( this.grid[r][c] == n ){
            	return false ;
         	}else{
         		return checkCol(r+1,c,n);
         	}
		}
        return true;
	}
	private boolean checkBlock(int r,int c, int n){
	 r = (r / 3) * 3 ;
     c = (c / 3) * 3 ;

      for( int i = 0; i < 3; i++ ){
         for( int j = 0; j < 3; j++ ){
         	if( grid[r+i][c+j] == n ){
            	return false ;
         	}
         }
	  }
      return true ;
	}

 
}
	
