import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.lang.String;
import javax.swing.JFileChooser;
import javax.swing.filechooser.FileFilter;
import java.io.*;

class GUI implements ActionListener{
	JLabel jlab2;
	JFrame jfrm;
	JButton jtbtn1,jtbtn2,jtbtn3,jtbtn4;
	JRadioButton rb1,rb2,rb3,rb4;
	File sf;
	Sudoku sdk;
	private JRadioButton radioButton3;
	private int[][] grid = null;
	private int[][] tmp = new int[9][9];
	private int tipoAlg=1;
	
	public GUI(){
		sdk= new Sudoku();
		//Create a new JFrame container
		jfrm = new JFrame("Sudoku solver");
		Container contentPane = jfrm.getContentPane();
		SpringLayout layout = new SpringLayout();
   		contentPane.setLayout(layout);
		jfrm.setResizable(false);
		jfrm.setLocationRelativeTo(null); 
		jfrm.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		//Create a label
		jlab2 = new JLabel("Andrea De Fanti VR089606");
		rb1 = new JRadioButton("Resolve for row");
		rb2 = new JRadioButton("Resolve for column");
		rb3 = new JRadioButton("Resolve in random mode");
		rb4 = new JRadioButton("MostConstrainedSquare heuristic");
		jtbtn1 = new JButton("Choose input file grid");
		jtbtn2 = new JButton("Automatic grid generation");
		jtbtn3 = new JButton("Reset input grid");
		jtbtn4 = new JButton("START!!");
		jtbtn1.addActionListener(this);
		jtbtn2.addActionListener(this);
		jtbtn3.addActionListener(this);
		jtbtn4.addActionListener(this);
		rb1.addActionListener(this);
		rb2.addActionListener(this);
		rb3.addActionListener(this);
		rb4.addActionListener(this);
		
		ButtonGroup group = new ButtonGroup();
		group.add(rb1);
		group.add(rb2);
		group.add(rb3);
		group.add(rb4);
    	contentPane.add(jlab2);
    	contentPane.add(jtbtn1);
    	contentPane.add(jtbtn2);
    	contentPane.add(jtbtn3);
    	contentPane.add(jtbtn4);
    	contentPane.add(rb1);
    	contentPane.add(rb2);
    	contentPane.add(rb3);
    	contentPane.add(rb4);
   		 layout.putConstraint(SpringLayout.WEST, jtbtn1, 10, SpringLayout.WEST, contentPane);
   		 layout.putConstraint(SpringLayout.NORTH, jtbtn1, 25, SpringLayout.NORTH, contentPane);
   		 layout.putConstraint(SpringLayout.WEST, jtbtn2, 200, SpringLayout.WEST, contentPane);
   		 layout.putConstraint(SpringLayout.NORTH, jtbtn2, 25, SpringLayout.NORTH, contentPane);
   		 layout.putConstraint(SpringLayout.WEST, jtbtn3, 10, SpringLayout.WEST, contentPane);
   		 layout.putConstraint(SpringLayout.NORTH, jtbtn3, 55, SpringLayout.NORTH, contentPane);
   		 layout.putConstraint(SpringLayout.WEST, jtbtn4, 200, SpringLayout.WEST, contentPane);
   		 layout.putConstraint(SpringLayout.NORTH, jtbtn4, 55, SpringLayout.NORTH, contentPane);
   		 layout.putConstraint(SpringLayout.WEST, jlab2, 130, SpringLayout.WEST, contentPane);
   		 layout.putConstraint(SpringLayout.NORTH, jlab2, 190, SpringLayout.NORTH, contentPane);
   		 layout.putConstraint(SpringLayout.WEST, rb1, 130, SpringLayout.WEST, contentPane);
   		 layout.putConstraint(SpringLayout.NORTH, rb1, 85, SpringLayout.NORTH, contentPane);
   		 layout.putConstraint(SpringLayout.WEST, rb2, 130, SpringLayout.WEST, contentPane);
   		 layout.putConstraint(SpringLayout.NORTH, rb2, 110, SpringLayout.NORTH, contentPane);
   		 layout.putConstraint(SpringLayout.WEST, rb3, 130, SpringLayout.WEST, contentPane);
   		 layout.putConstraint(SpringLayout.NORTH, rb3, 135, SpringLayout.NORTH, contentPane);
   		 layout.putConstraint(SpringLayout.WEST, rb4, 130, SpringLayout.WEST, contentPane);
   		 layout.putConstraint(SpringLayout.NORTH, rb4, 160, SpringLayout.NORTH, contentPane);
   		// frame dimension
   		jfrm.setSize(410,250);
   		rb1.doClick();
		jfrm.setVisible(true);	
	}	
	public static void main(String args[]){
		//Create the frame on the event dispatching thread
		SwingUtilities.invokeLater(new Runnable() {
			public void run(){
				new GUI();
			}
		});	
	}
	public void actionPerformed(ActionEvent ae){
		String ac = ae.getActionCommand();
		if(ac.equals("Choose input file grid")){
			JFileChooser chooser = new FileChooser();
       		chooser.setMultiSelectionEnabled(false);
       		FileFilter filter1 = new ExtensionFileFilter("TXT", new String[] { "TXT", "txt" });
    		chooser.setFileFilter(filter1);
    		this.grid=null;
       		try{	
       			 chooser.setCurrentDirectory(new File(new File (".").getCanonicalPath()));
       		}catch (Exception ex){
       			 	
       		}	 
       		int option = chooser.showOpenDialog(jfrm);
       		
        	if (option == JFileChooser.APPROVE_OPTION) {
          		sf = chooser.getSelectedFile();
        	}
		}else if(ac.equals("Reset input grid")){ 
			this.grid=null;
			this.sf=null;
			System.out.println("Reset grid");
		}else if(ac.equals("Resolve for row")){ 
			tipoAlg=1;
		}else if(ac.equals("Resolve for column")){ 
			tipoAlg=2;
		}else if(ac.equals("Resolve in random mode")){ 
			tipoAlg=3;
		}else if(ac.equals("MostConstrainedSquare heuristic")){ 
			tipoAlg=4;
		}else if(ac.equals("Automatic grid generation")){	
						this.sf=null;		
						//use only for generate random grid
							
							if(grid == null){
        					grid=Sudoku.createRandomGrid(1);
						}
												
		}else{
			try {
						
						if(sf != null){
                			Sudoku.readBoard(sf,tipoAlg);
                	
						}else if(grid != null){
							//copy old grid
							for(int i=0;i<9;i++){
								for(int j=0;j<9;j++){
								tmp[i][j]=grid[i][j];	
								}
							}
							Sudoku.run(tmp,tipoAlg);
									
						}else{
							System.out.println("Invalid input grid");	
						}
					
               }catch (Exception ex){
        			System.out.println(ex);
        	   }	 	
			
		}
	}
}

class ExtensionFileFilter extends FileFilter {
  String description;

  String extensions[];

  public ExtensionFileFilter(String description, String extension) {
    this(description, new String[] { extension });
  }

  public ExtensionFileFilter(String description, String extensions[]) {
    if (description == null) {
      this.description = extensions[0];
    } else {
      this.description = description;
    }
    this.extensions = (String[]) extensions.clone();
    toLower(this.extensions);
  }

  private void toLower(String array[]) {
    for (int i = 0, n = array.length; i < n; i++) {
      array[i] = array[i].toLowerCase();
    }
  }

  public String getDescription() {
    return description;
  }

  public boolean accept(File file) {
    if (file.isDirectory()) {
      return true;
    } else {
      String path = file.getAbsolutePath().toLowerCase();
      for (int i = 0, n = extensions.length; i < n; i++) {
        String extension = extensions[i];
        if ((path.endsWith(extension) && (path.charAt(path.length() - extension.length() - 1)) == '.')) {
          return true;
        }
      }
    }
    return false;
  }
}

class FileChooser extends JFileChooser {
    protected JDialog createDialog(Component parent) throws HeadlessException {
	    JDialog dialog = super.createDialog(parent);
	    dialog.setLocation(100, 100);
	    return dialog;
	}
}