import java.awt.* ;
import java.io.*;
import javax.swing.*;
import java.lang.*;
import java.util.*;

public class Sudoku
{
	private static Solver so;
   protected static Button view[][] ;
 	private static JFrame mainFrame;
   
   public Sudoku(){
   		super();
   }

   private static void createView(){
		if (mainFrame != null)
			mainFrame.dispose();
			
		mainFrame = new JFrame();
        mainFrame.setLayout( new GridLayout(9,9) ) ;

	view = new Button[9][9] ;

      	// an empty view
      	for( int r = 0; r < 9; r++ )
        	for( int c = 0; c < 9; c++ ){
	            view[r][c]  = new Button("  ") ;
        	    mainFrame.add( view[r][c] ) ;
         	}

         mainFrame.setSize(600, 600);
         mainFrame.addWindowListener(new java.awt.event.WindowAdapter() {
   			public void windowClosing(java.awt.event.WindowEvent e) {
       		if (so != null)
     				((BaseSolver) so).stop = true;
   			}
		 });
         mainFrame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
         mainFrame.setVisible(true);
   }
   public static void run(int[][] g,int t){
   	long t1,t2;
   				createView();
   				if (t==1){
   					so=new BackTrack1();
   				}else if (t==2){
   					so=new BackTrack2();
   				}else if (t==3){
   					so=new BackTrack3();
   				}else if (t==4){ 
   					so=new BackTrack4();	
   				}
   			   	so.setGrid(g);
   			    so.setView(view);
   	 			new SolverRunner(so); 
   }
   public static void readBoard(File f,int t){
		int[][] field = new int[9][9] ;
		String line;
		Solver old=null;
		int r=0;
		int n=0;
		emptyGrid(field);
		if (t==1){
   			old=new BackTrack1();
   		}else if (t==2){
   			old=new BackTrack2();
   		}else if (t==3){
   			old=new BackTrack3();
   		}else if (t==4){
   			old=new BackTrack4();	
   		}
			old.setGrid(field);
		try{
			BufferedReader bf= new BufferedReader(new FileReader(f));
			bf.readLine();
			while((line=bf.readLine()) != null){
				line=line.trim();
				line=line.replace(".","0");
				line=line.replace("|","");
				line=line.replace("  "," ");
				line=line.replace(" ",";");
				String split[] = line.split(";");
				if (split.length > 1){
					for(int c=0; c < 9; c++){
						n=Integer.parseInt(split[c]);
						if(n != 0){ 
							if(old.checkConsistency(r,c,n)){
								field[r][c]=n;
							}else{
								throw new Exception("Bad grid Format");		
							}		
						}
					}					
				r++;
				}
			}
			bf.close();
			old=null;
   			run(field,t);
			}catch(Exception e){
				System.out.println("Bad grid Format! Check the input grid");
		}	
		
	}
	public static int[][] createRandomGrid(int t)
   {
   	Solver old=null;
	int[][] field = new int[9][9];
	int[][] tmp = new int[9][9];
	int r,c,n=0;
	int ct=0;
  	
  	emptyGrid(field);
 
  	if (t==1){
   		old=new BackTrack1();
   	}else if (t==2){
   		old=new BackTrack2();
   	}else if (t==3){
   		old=new BackTrack3();
   	}else if (t==4){
   		old=new BackTrack4();	
   	}
  	old.setGrid(field);
  	// 17 variables give a unique solution and hard problem
	while(ct < 17){
		r=(int)(9*Math.random());
		c=(int)(9*Math.random());
	  	n=(int)(9*Math.random())+1;
		// field empty and checkConsistency
		if(field[r][c] == 0 && old.checkConsistency(r,c,n)){
			field[r][c]=n;
			ct++;
		}		
	}
	// save the grid on the file	
	saveRandomGrid(field);  
      	return field;	
   } 
   private static void emptyGrid(int[][] tmp){
   	for(int i=0;i< 9;i++){
  		for(int j=0;j<9;j++){
  			tmp[i][j]=0;
  		}
  	}
   }
   private static void saveRandomGrid(int[][] field){
   		String name= Integer.toString((int)(1024*Math.random())+1);
   		FileWriter f= null;
   		try{
   			f= new FileWriter("./grid/RandomGrid-"+ name +".txt");
   			f.write("% randomly generated \n");
		for (int i=0; i < 9; i++) {
			for(int j=0; j < 9; j++){	
				if(j !=	8){			
					f.write(""+ field[i][j]+";");
				}else{
					f.write(""+ field[i][j]);
				}
			}
				f.write("\n");
				f.flush();
		}
			f.close();
   		}catch(Exception e){
   			
   		}
	} 
 }
